--require 'love.thread'
require 'love.timer'
require 'love.image'
require 'love.filesystem'

require 'TSerial'
require 'complex'
require 'sphere'
require 'colorTab'

im = love.image
tm = love.timer
tr = love.thread

tr	= love.thread.getThread()


function showBox()
    -- let's for old mode
--    str1 = "{"..Bmx1..","..Bmx2..","..Bmy1..","..Bmy2.."},"
--    print(str1)
--    str1 = "{"..Mxc..","..Myc..","..Mrd.." },"
--    print(str1)
end


function fillImage(x,y,r,g,b,a)
  r = 200 g = 200 b = 200 a = 200
  return r,g,b,a
end

tabSize={
  { 100,  100},
  { 200,  200},
  { 300,  400}, 
  { 400,  300},
  { 800,  600},
  {1000,  800},
  {1200, 1000},
  {1600, 1200},
  {2000, 1600},
  {2000, 2000}
}
SizeX=10 SizeY=10
function setSize(n)
  if tabSize[n]== nil then
    SizeX=tabSize[1][1]    SizeY=tabSize[1][2]
  else      
    SizeX=tabSize[n][1]    SizeY=tabSize[n][2]
  end
  imageD = im.newImageData(SizeX,SizeY)
  imageDBase = im.newImageData(SizeX,SizeY)
  imageD:mapPixel(fillImage)
  tr:set('id2rK',imageD) -- pass reference
  tr:set('id2rK1',imageDBase)
  
  --print("qui")
  
end

setSize(1)





buildColorsTab()


C2tab={}  
C2max = 0



Pts={}
Idx = 1


local Z , C
local cx

function f1a(zr,zi,cr,ci) -- z = z^2+c
    z = complex.new(zr,zi)
    c = complex.new(cr,ci)
    z = complex.mul(z,z)
    z = complex.add(z,c)
    return z
end


function f1(r,i)
    local n,dist,z
    C = complex.new(r,i)
    Z = complex.new(0,0)
    z = complex.new(0,0)
    dist = 0
    n = 0
    while dist < 4 and n < MAXITER do
      z.r = Z.r*Z.r - Z.i*Z.i 
      z.i = Z.r*Z.i + Z.r*Z.i 
      Z.r = z.r + C.r
      Z.i = z.i + C.i
      dist = Z.r*Z.r + Z.i*Z.i -- appartiene a mandelbrot se dist^2 < escapeValue(suppose 4)
      n = n+1
    end
    
    --[[  --http://linas.org/art-gallery/escape/escape.html
      Z = Z*Z +C; iter_count ++;    // a couple of extra iterations helps
      Z = Z*Z +C; iter_count ++;    // decrease the size of the error term.
      float modulus = sqrt (ReZ*ReZ + ImZ*ImZ);
      float mu = iter_count - (log (log (modulus)))/ log (2.0);
      color_value = colormap_lookup (mu);
      draw_pixel (C, color_value);    
      -----------------------------------------------------
      z = z * z + C; iteration++;
      z = z * z + C; iteration++;
      double mu = iteration - (Math.Log(Math.Log(z.Modulus))) / logEscapeRadius;
      colorIndex = (int)(mu / maxIteration * 768);
      if (colorIndex >= 768) colorIndex = 0;
      if (colorIndex < 0) colorIndex = 0;
    ]]    
    
--    cx = complex.mul(z,z) cx = complex.add(cx,c)  z = cx  
--    cx = complex.mul(z,z) cx = complex.add(cx,c)  z = cx
--    n=n+2
--    modulus = math.sqrt(z.r*z.r+z.i*z.i)
--    local mu = n - (math.log (math.log(modulus)))/(math.log(2))
--    n1 = math.floor(mu)
--    if n1 < 0 then n1=0 end
--    if n1 > MAXITER then n1 = MAXITER end
    
    return n 
    
end




redo = false



Mxc = 0  Myc = 0  Mrd = 0

live = 0

 local idxc = 0
 --local tabColorLen = #tabColor
 
local MAXITER_prepare = MAXITER

while true do
  
  
  if tr:get('c2') or redo then
    
    MAXITER = MAXITER_prepare
    
    tr:set('id2r',imageD) -- pass reference
    
    tm1 = love.timer.getMicroTime()
    
    local dxr,dyr,n2,x,y,iw,ih
    local r,g,b,a,c,v
    local r,i
    local idx
    
    n2 = 1
    tr:set('nn2',n2)
    
    
    iw = imageD:getWidth()  
    ih = imageD:getHeight() 
    
    ------ old system --------  
    --mx1a = tr:get('mx1',mx1)    mx2a = tr:get('mx2',mx2) 
    --my1 = tr:get('my1',my1)    my2 = tr:get('my2',my2) 
    
    ------------------- change xxratio
    --    local xc,dxm,ratio
    --    ratio = iw/ih
    --    dxm = math.abs(mx1a-mx2a)/2
    --    xc = mx1a+dxm
    --    mx1 = xc - dxm * ratio
    --    mx2 = xc + dxm * ratio
    ----------------------------------
    
    
    ---------------------- new system --------------
    -- need only mx1,dxr my1,dyr
    Mxc = tr:get('Mxc')
    Myc = tr:get('Myc')
    Mrd = tr:get('Mrd')
    
    local rmin,rtx,rty
    rmin = math.min(iw,ih)
    rtx = iw/rmin  -- 1 or 1,xxx
    rty = ih/rmin   -- 1 or 1,xxx
    
    dxr = Mrd * rtx
    dyr = Mrd * rty
    
    ----------------------------------
    Bmx1 = Mxc - dxr
    Bmy1 = Myc - dyr
    
    Bmx2 = Mxc + dxr
    Bmy2 = Myc + dyr
    
    showBox()
    ----------------------------------
    
    
    Pts[1]=iw
    Pts[2]=ih
    Idx = 3
    
    for i=0,MAXITER do C2tab[i] = 0 end
    
    
    ------------------------------  build image -----------------------------
    for y=0,ih-1,1 do
      
        for x =0,iw-1,1 do
        
          r = Bmx1 + 2*dxr * (x / iw) 
          i = Bmy1 + 2*dyr * (y / ih)
          
          v = f1(r,i)
          
          
          --Pts[Idx]=v  Idx=Idx+1
          
          -- istogram
          if(v <= MAXITER) then  C2tab[v] = C2tab[v]+1 -- don't update at MAXITER
          -----------
          
          
          idxc = math.floor(NumColors * (v/MAXITER))
      --print("qui "..idxc.." "..NumColors.."  "..v)
          
          r=tabColor[idxc][1] 
          g=tabColor[idxc][2] 
          b=tabColor[idxc][3] 
          a=tabColor[idxc][4]
          
      --print("qui")
          
          
          imageD:setPixel(x,y,r,g,b,a)
          
         
          ------------- 16 bit escap numbers stored in r,g,b
          g = math.floor(v / 256)
          b = math.floor(v - (g * 256))
          imageDBase:setPixel(x,y,0,g,b,255)
          ----------------------------------------
          
          
          n2 = n2+1
          if (n2 % 100)==0 then
            tr:set('nn2',n2)
            tr:set('id2rK',imageD)
            tr:set('id2rK1',imageDBase)
          end
          
        end
        
      end
      
      
--      if tr:peek('c2') then
--        redo = true
--        break
--      end
  
      if tr:get('stop') then
        break
      end
      
    end
     --------------------------  end build image ----------------------------
    
    if tr:get('c2') then -- clear
      --      mx1 = tr:get('mx1',mx1)    mx2 = tr:get('mx2',mx2) 
      --      my1 = tr:get('my1',my1)    my2 = tr:get('my2',my2) 
      local xx
      xx = tr:get('Mxc')
      xx = tr:get('Myc')
      xx = tr:get('Mrd')
    end
    
    
    dt1 = love.timer.getMicroTime() - tm1
    
    local str = TSerial.pack(C2tab)
    tr:set('C2tabStr',str)


    tr:set('id2r',imageD)
    tr:set('done2',true)
    
  end
  
  if tr:get('saveData') then
    print("saving data...")
    local str1 = "IMG_"..os.time()..".png"
    imageD:encode(str1)
    print("saved.")
  end  
  
--  if tr:get('size1') then SizeX = 133  SizeY = 100 setSize() end  
--  if tr:get('size2') then SizeX = 200  SizeY = 200 setSize() end  
--  if tr:get('size3') then SizeX = 300  SizeY = 300 setSize() end  
--  if tr:get('size4') then SizeX = 300  SizeY = 400 setSize() end  
--  if tr:get('size5') then SizeX = 500  SizeY = 500 setSize() end  
--  if tr:get('size6') then SizeX = 600  SizeY = 100 setSize() end  
--  if tr:get('size7') then SizeX = 800  SizeY = 600 setSize() end  
--  if tr:get('size8') then SizeX = 1000 SizeY = 1000 setSize() end  
--  if tr:get('size9') then SizeX = 1200 SizeY = 1000 setSize() end  
  
  
  if tr:peek('size') then 
    local n = tr:get('size') 
    setSize(n)
  end
  
--  if tr:peek('buildCT') then
--    MAXITER = tr:get('buildCT')  
--    print("qui2")
--    buildColorsTab()
--    buildColorsTabL()
--    print("qui1")
--  end
  
  
  if tr:peek('maxiter') then
    MAXITER_prepare = tr:get('maxiter')  
  end
  
  
  live = live + 1
  --print (live)
  
  ----------------------------------------------------
  
--  ----------------------------------------------------
--  if tr:get('c3') then
--    print("".."mx1="..mx1.."\r\nmx2="..mx2.."\r\nmy1="..my1.."\r\nmy2="..my2.."\r\n")
--  end
--  ----------------------------------------------------
  
  
end

    